package com.viettel.einvoice.service.impl;

import com.viettel.einvoice.config.properties.BaseServiceProperties;
import com.viettel.einvoice.config.properties.EInvoiceProperties;
import com.viettel.einvoice.service.BaseService;
import com.viettel.einvoice.utils.PasswordUtils;
import org.apache.commons.codec.binary.Base64;

import java.nio.charset.Charset;
import java.util.Map;
import java.util.Set;

public class BaseServiceImpl implements BaseService {
    private String api;
    private String method;
    private String username;
    private String password;

    public String getApi() {
        return api;
    }

    public void setApi(String api) {
        this.api = api;
    }

    public String getMethod() {
        return method;
    }

    public void setMethod(String method) {
        this.method = method;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getHost(EInvoiceProperties eInvoiceProperties) {
        return eInvoiceProperties.getProtocol() + "://"
                + eInvoiceProperties.getHost() + ":"
                + eInvoiceProperties.getPort() + "/";
    }

    public String setParamsToUrl(Map<String, String> params, String url) {
        String result = url;

        if (params != null || !params.isEmpty()) {
            Set<String> keys = params.keySet();
            for (String key : params.keySet()) {
                if (url.contains(key)) {
                    result = result.replaceAll(":" + key, params.get(key));
                } else {
                    keys.remove(key);
                }
            }

            if (!keys.isEmpty()) {
                Object[] arrKeys = keys.toArray();
                for (int i = 0; i < arrKeys.length; i++) {
                    if (i == 0) {
                        result = result + "?" + arrKeys[i] + "=" + params.get(arrKeys[i]);
                    } else {
                        result = result + "&" + arrKeys[i] + "=" + params.get(arrKeys[i]);
                    }
                }
            }
        }
        return result;
    }

    public String getAuthentication() {
        String userNameDecode = PasswordUtils.viettelDecrypt(username);
        String passwordDecode = PasswordUtils.viettelDecrypt(password);
        String strAuth = userNameDecode + ":" + passwordDecode;
        return "Basic " + new String(Base64.encodeBase64(strAuth.getBytes(Charset.forName("utf-8"))));
    }
}
