package com.viettel.einvoice.service;

import com.google.gson.Gson;
import com.viettel.einvoice.service.impl.InvoiceServiceImpl;
import com.viettel.einvoice.service.object.InvoiceCancelObject;
import com.viettel.einvoice.service.object.InvoiceCreateObject;
import com.viettel.einvoice.service.object.InvoiceFileObject;
import com.viettel.einvoice.service.object.InvoiceHashObject;
import com.viettel.einvoice.utils.FileJsonUtils;
import com.viettel.einvoice.utils.FileUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Paths;
import java.util.*;

public class InvoiceServiceTest {

    private final Logger logger = LoggerFactory.getLogger(InvoiceServiceTest.class);

    void create() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        Map<String, String> params = new HashMap<>();
        params.put("supplierTaxCode", "0302403742");
        System.out.print(invoiceService.create(params, FileJsonUtils.instance().readFileResource("datatest/HDGoc.txt", InvoiceCreateObject.class)));
    }

    void createDraft() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        Map<String, String> params = new HashMap<>();
        params.put("supplierTaxCode", "0302403742");
        System.out.print(invoiceService.createDraft(params, FileJsonUtils.instance().readFileResource("datatest/HDGoc.txt", InvoiceCreateObject.class)));
    }

    void createBatch() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        Map<String, String> params = new HashMap<>();
        params.put("supplierTaxCode", "0302403742");
        InvoiceCreateObject invoiceCreateObject = FileJsonUtils.instance().readFileResource("datatest/HDGoc.txt", InvoiceCreateObject.class);
        List<InvoiceCreateObject> invoiceCreateObjects = new ArrayList<>();
        invoiceCreateObjects.add(invoiceCreateObject);
        invoiceCreateObjects.add(invoiceCreateObject);
        invoiceCreateObjects.add(invoiceCreateObject);
        System.out.print(invoiceService.createBatch(params, invoiceCreateObjects));
    }

    void createWithUsbTokenGetHash() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        Map<String, String> params = new HashMap<>();
        params.put("supplierTaxCode", "0302403742");
        System.out.print(invoiceService.createWithUsbTokenGetHash(params, FileJsonUtils.instance().readFileResource("datatest/HDGoc.txt", InvoiceCreateObject.class)));
    }

    void createWithUsbTokenInsertHash() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        Map<String, String> params = new HashMap<>();
        params.put("supplierTaxCode", "0302403742");
        System.out.print(invoiceService.createWithUsbTokenInsertHash(FileJsonUtils.instance().readFileResource("datatest/HDGoc.txt", InvoiceHashObject.class)));
    }

    void createFileExchange() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        Map<String, String> params = new HashMap<>();
        params.put("supplierTaxCode", "0302403742");
        System.out.print(invoiceService.createFileExchange(FileJsonUtils.instance().readFileResource("datatest/HDGoc.txt", InvoiceFileObject.class)));
    }


    void cancel() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        Map<String, String> params = new HashMap<>();
        params.put("supplierTaxCode", "0302403742");
        System.out.print(invoiceService.cancel(FileJsonUtils.instance().readFileResource("datatest/HDGoc.txt", InvoiceCancelObject.class)));
    }

    void getCustomFields() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        Map<String, String> params = new HashMap<>();
        params.put("supplierTaxCode", "0302403742");
        params.put("taxCode", "0302403742");
        System.out.print(invoiceService.getCustomFields(params));
    }

    void updateTaxDeclaration() {
        InvoiceService invoiceService = new InvoiceServiceImpl();
        System.out.print(invoiceService.updateTaxDeclaration("0302403742", new Date()));
    }

}
