package com.viettel.einvoice.utils;

import com.google.gson.Gson;

import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Paths;

public class FileJsonUtils {

    private static FileJsonUtils fileJsonUtils;

    public static FileJsonUtils instance() {
        fileJsonUtils = new FileJsonUtils();
        return fileJsonUtils;
    }

    public <T> T readFileResource(String file, Class<T> clazz) {
        try {
            URL url = this.getClass().getClassLoader().getResource(file);
            String json = FileUtils.readFile(Paths.get(url.toURI()));
            Gson gson = new Gson();
            T object = gson.fromJson(json, clazz);
            return object;
        } catch (URISyntaxException e) {
            e.printStackTrace();
        }
        return null;
    }
}
