/*
 * Copyright 2014 Viettel Software. All rights reserved.
 * VIETTEL PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.viettel.einvoice.model;

import com.viettel.einvoice.model.adapter.DecimaAdapter;
import java.math.BigDecimal;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

/**
 * @version 1.0
 * @since Apr 16, 2015
 * @author kientt6
 */
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class ItemInfo {

    private Integer lineNumber;//UnsignedInt Thứ tự dòng hóa đơn, bắt đầu từ 1

    private String itemCode;//Mã hàng hóa, dịch vụ

    //Tuanna bo sung selection
    private Integer selection;//Mã hàng hóa, dịch vụ

    private String itemName;//Tên hàng hóa, dịch vụ

    private String unitCode;//Mã đơn vị tính TM: Tiền mặt CK: Chuyển khoản

    private String unitName;//Tên đơn vị tính hàng hóa, dịch vụ

    private String itemNote;//Ghi chu them cho hang hoa, dich vu

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal unitPrice;// Decimal	(15,2)	Đơn giá

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal quantity;//Decimal	(15,2) Số lượng
    //private BigDecimal itemTotalAmountWithoutVat;//Decimal	(15,2)	Hóa đơn thường: Là tổng tiền hàng hóa dịch vụ chưa có VAT. Hóa đơn điều chỉnh: Là tổng tiền phần điều chỉnh của hàng hóa dịch vụ chưa có VAT

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal itemTotalAmountWithoutTax;//Decimal	(15,2)	Hóa đơn thường: Là tổng tiền hàng hóa dịch vụ chưa có VAT. Hóa đơn điều chỉnh: Là tổng tiền phần điều chỉnh của hàng hóa dịch vụ chưa có VAT
    //private BigDecimal vatPercentage;//Decimal (7,3) Thuế suất của hàng hóa, dịch vụ

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal itemTotalAmountWithTax;//Decimal	(15,2)	Hóa đơn thường: Là tổng tiền hàng hóa dịch vụ chưa có VAT. Hóa đơn điều chỉnh: Là tổng tiền phần điều chỉnh của hàng hóa dịch vụ chưa có VAT

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal itemTotalAmountAfterDiscount;

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal taxPercentage;//Decimal (7,3) Thuế suất của hàng hóa, dịch vụ
    //private BigDecimal vatAmount;//Decimal	(15,2)	Tổng tiền thuế

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal taxAmount;//Decimal	(15,2)	Tổng tiền thuế
    private Boolean promotion;//Cho biết loại hàng hóa dịch vụ là khuyến mãi hay không:True:  hàng khuyến mãi False: hàng hóa thường
    //private BigDecimal adjustmentVatAmount;//Decimal		Hóa đơn thường: có giá trị là Null. Hóa đơn điều chỉnh: Tổng giá trị tiền thuế bị  điều chỉnh

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal adjustmentTaxAmount;//Decimal		Hóa đơn thường: có giá trị là Null. Hóa đơn điều chỉnh: Tổng giá trị tiền thuế bị  điều chỉnh

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal discount;

    @XmlJavaTypeAdapter(DecimaAdapter.class)
    private BigDecimal itemDiscount;

    private Boolean isIncreaseItem;//Boolean. Hóa đơn bình thường: có giá trị là Null.Hóa đơn điều chỉnh:- False: dòng hàng hóa dịch vụ bị điều chình giảm - True: dòng hàng hóa dịch vụ bị điều chỉnh tăng

    private String batchNo;//So lo, chi co gia tri hien thi ve mat du lieu

    private String expDate;//Han dung, chi co gia tri hien thi ve mat du lieu

    public Integer getLineNumber() {
        return lineNumber;
    }

    //(name = "lineNumber", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setLineNumber(Integer lineNumber) {
        this.lineNumber = lineNumber;
    }

    public String getItemCode() {
        return itemCode;
    }

    //(name = "itemCode", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setItemCode(String itemCode) {
        this.itemCode = itemCode;
    }

    public String getItemName() {
        return itemName;
    }

    //(name = "selection", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setSelection(Integer selection) {
        this.selection = selection;
    }

    public Integer getSelection() {
        return selection;
    }

    //(name = "itemName", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setItemName(String itemName) {
        this.itemName = itemName;
    }

    public String getUnitCode() {
        return unitCode;
    }

    //(name = "unitCode", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setUnitCode(String unitCode) {
        this.unitCode = unitCode;
    }

    public String getUnitName() {
        return unitName;
    }

    //(name = "unitName", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setUnitName(String unitName) {
        this.unitName = unitName;
    }

    public BigDecimal getUnitPrice() {
        return unitPrice;
    }

    //(name = "unitPrice", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setUnitPrice(BigDecimal unitPrice) {
        this.unitPrice = unitPrice;
    }

    public BigDecimal getQuantity() {
        return quantity;
    }

    //(name = "quantity", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setQuantity(BigDecimal quantity) {
        this.quantity = quantity;
    }

    //    public BigDecimal getItemTotalAmountWithoutVat() {
    //        return itemTotalAmountWithoutVat;
    //    }
    //    //(name = "itemTotalAmountWithoutVat", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    //    public void setItemTotalAmountWithoutVat(BigDecimal itemTotalAmountWithoutVat) {
    //        this.itemTotalAmountWithoutVat = itemTotalAmountWithoutVat;
    //    }
    public BigDecimal getItemTotalAmountWithoutTax() {
        return itemTotalAmountWithoutTax;
    }

    public void setItemTotalAmountWithoutTax(BigDecimal itemTotalAmountWithoutTax) {
        this.itemTotalAmountWithoutTax = itemTotalAmountWithoutTax;
    }

//    public BigDecimal getVatPercentage() {
//        return vatPercentage;
//    }
//    //(name = "vatPercentage", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
//    public void setVatPercentage(BigDecimal vatPercentage) {
//        this.vatPercentage = vatPercentage;
//    }
    public BigDecimal getTaxPercentage() {
        return taxPercentage;
    }

    public void setTaxPercentage(BigDecimal taxPercentage) {
        this.taxPercentage = taxPercentage;
    }

//    public BigDecimal getVatAmount() {
//        return vatAmount;
//    }
//    //(name = "vatAmount", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
//    public void setVatAmount(BigDecimal vatAmount) {
//        this.vatAmount = vatAmount;
//    }
    public BigDecimal getTaxAmount() {
        return taxAmount;
    }

    public void setTaxAmount(BigDecimal taxAmount) {
        this.taxAmount = taxAmount;
    }

    public Boolean getPromotion() {
        return promotion;
    }

    //(name = "promotion", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setPromotion(Boolean promotion) {
        this.promotion = promotion;
    }

//    public BigDecimal getAdjustmentVatAmount() {
//        return adjustmentVatAmount;
//    }
//    //(name = "adjustmentVatAmount", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
//    public void setAdjustmentVatAmount(BigDecimal adjustmentVatAmount) {
//        this.adjustmentVatAmount = adjustmentVatAmount;
//    }
    public BigDecimal getAdjustmentTaxAmount() {
        return adjustmentTaxAmount;
    }

    public void setAdjustmentTaxAmount(BigDecimal adjustmentTaxAmount) {
        this.adjustmentTaxAmount = adjustmentTaxAmount;
    }

    public BigDecimal getDiscount() {
        return discount;
    }

    public void setDiscount(BigDecimal discount) {
        this.discount = discount;
    }

    public BigDecimal getItemDiscount() {
        return itemDiscount;
    }

    public void setItemDiscount(BigDecimal itemDiscount) {
        this.itemDiscount = itemDiscount;
    }

    public Boolean getIsIncreaseItem() {
        return isIncreaseItem;
    }

    //(name = "isIncreaseItem", namespace = "http://laphoadon.gdt.gov.vn/2014/09/invoicexml/v1")
    public void setIsIncreaseItem(Boolean isIncreaseItem) {
        this.isIncreaseItem = isIncreaseItem;
    }

    public String getItemNote() {
        return itemNote;
    }

    public void setItemNote(String itemNote) {
        this.itemNote = itemNote;
    }

    public String getBatchNo() {
        return batchNo;
    }

    public void setBatchNo(String batchNo) {
        this.batchNo = batchNo;
    }

    public String getExpDate() {
        return expDate;
    }

    public void setExpDate(String expDate) {
        this.expDate = expDate;
    }

    public BigDecimal getItemTotalAmountWithTax() {
        return itemTotalAmountWithTax;
    }

    public void setItemTotalAmountWithTax(BigDecimal itemTotalAmountWithTax) {
        this.itemTotalAmountWithTax = itemTotalAmountWithTax;
    }

    public BigDecimal getItemTotalAmountAfterDiscount() {
        return itemTotalAmountAfterDiscount;
    }

    public void setItemTotalAmountAfterDiscount(BigDecimal itemTotalAmountAfterDiscount) {
        this.itemTotalAmountAfterDiscount = itemTotalAmountAfterDiscount;
    }
}
