﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ViettelAPI.Models;
using Newtonsoft.Json;
using System.IO;
using ViettelAPI;
using System.Configuration;

namespace Sample
{
    class Program
    {
        static void Main(string[] args)
        {
            // thong so
            string domain = !string.IsNullOrEmpty(ConfigurationManager.AppSettings["DOMAIN"]) ? ConfigurationManager.AppSettings["DOMAIN"] : null;
            string codeTax = !string.IsNullOrEmpty(ConfigurationManager.AppSettings["CODETAX"]) ? ConfigurationManager.AppSettings["CODETAX"] : null;
            string apiLink = domain + @"/InvoiceAPI/InvoiceWS/createBatchInvoice/" + codeTax;
            string userName = !string.IsNullOrEmpty(ConfigurationManager.AppSettings["USERNAME"]) ? ConfigurationManager.AppSettings["USERNAME"] : null;
            string passWord = !string.IsNullOrEmpty(ConfigurationManager.AppSettings["PASSWORD"]) ? ConfigurationManager.AppSettings["PASSWORD"] : null;


            // tao list InvoiceModel
            string filePath = Path.GetDirectoryName(Environment.GetCommandLineArgs()[0]) + "\\Sample\\pullman_sample.json";
            //string filePath = !string.IsNullOrEmpty(ConfigurationManager.AppSettings["FILEPATH"]) ? ConfigurationManager.AppSettings["FILEPATH"] : null;
            string file = File.ReadAllText(filePath);
            List<InvoiceModels> lstInvoice = JsonConvert.DeserializeObject<List<InvoiceModels>>(file);


            // call api
            ProcessInvoice process = new ProcessInvoice(apiLink, codeTax, userName, passWord);
            APIResults results = process.IssueInvoices(lstInvoice);


            // write kết quả ra console 
            foreach (APIResult result in results.createInvoiceOutputs)
            {
                if (!string.IsNullOrEmpty(result.errorCode))
                {
                    Console.WriteLine("Error code: " + result.errorCode);
                    Console.WriteLine("Description: " + result.description);
                }
                else
                {
                    Console.WriteLine("TransactionUid: " + result.transactionUuid);
                    Console.WriteLine("Supplier tax code: " + result.result.supplierTaxCode);
                    Console.WriteLine("Invoice No.: " + result.result.invoiceNo);
                    Console.WriteLine("Reservation code: " + result.result.reservationCode);
                    Console.WriteLine("Transaction ID: " + result.result.transactionID);
                }
            }
            Console.ReadLine();
        }
    }
}
