﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;

using ViettelAPI.Models;
using ViettelAPI.Utils;

namespace ViettelAPI
{
    public class ProcessInvoice
    {
        string CodeTax;
        string ApiLink;
        string Username;
        string Password;
        string ContentType = "application/json";

        /// <summary>
        /// Hàm khởi tạo
        /// </summary>
        /// <param name="apiLink">đường dẫn api</param>
        /// <param name="taxCode">mã số thuế</param>
        /// <param name="username">tên đăng nhập</param>
        /// <param name="password">mật khẩu</param>
        public ProcessInvoice(string apiLink, string taxCode, string username, string password)
        {
            this.ApiLink = apiLink;
            this.CodeTax = taxCode;
            this.Username = username;
            this.Password = password;
        }

        /// <summary>
        /// Phát hành lô hóa đơn
        /// </summary>
        /// <param name="dsHoaDon"> danh sách hóa đơn sẽ phát hành</param>
        /// <returns></returns>
        public APIResults IssueInvoices(List<InvoiceModels> dsHoaDon)
        {
            string userPass = this.Username + ":" + this.Password;
            string autStr = ApiUtils.Base64Encode(userPass);
            string data = JsonConvert.SerializeObject(dsHoaDon);
            string loHoaDon = "{\"commonInvoiceInputs\": " + data + " }";

            string result = ApiUtils.Request(ApiLink, loHoaDon, autStr, "POST", this.ContentType);
            var resultConverted = ApiUtils.ParseResult<APIResults>(result);
            return resultConverted;
        }

    }
}
